Subject: built-in-submodule & in-flight dependencies (was: What's cooking in git.git (Dec 2022, #07; Mon, 26))

From: Ævar Arnfjörð Bjarmason <[email-masked]>
Date: Wed, 28 Dec 2022 09:36:43 +0100

On Mon, Dec 26 2022, Junio C Hamano wrote:

> [...]
> [Cooking]
>
> * ab/no-more-git-global-super-prefix (2022-12-26) 9 commits
>  - read-tree: add "--super-prefix" option, eliminate global
>  - submodule--helper: convert "{update,clone}" to their own "--super-prefix"
>  - submodule--helper: convert "status" to its own "--super-prefix"
>  - submodule--helper: convert "sync" to its own "--super-prefix"
>  - submodule--helper: convert "foreach" to its own "--super-prefix"
>  - submodule--helper: don't use global --super-prefix in "absorbgitdirs"
>  - submodule.c & submodule--helper: pass along "super_prefix" param
>  - read-tree + fetch tests: test failing "--super-prefix" interaction
>  - submodule absorbgitdirs tests: add missing "Migrating git..." tests
>
>  Stop using "git --super-prefix" and narrow the scope of its use to
>  the submodule--helper.
>
>  Will merge to 'next'.
>  source: <[email-masked]>
> [...]
> * ab/config-multi-and-nonbool (2022-11-27) 9 commits
>  - for-each-repo: with bad config, don't conflate <path> and <cmd>
>  - config API: add "string" version of *_value_multi(), fix segfaults
>  - config API users: test for *_get_value_multi() segfaults
>  - for-each-repo: error on bad --config
>  - config API: have *_multi() return an "int" and take a "dest"
>  - versioncmp.c: refactor config reading next commit
>  - config tests: add "NULL" tests for *_get_value_multi()
>  - config tests: cover blind spots in git_die_config() tests
>  - for-each-repo tests: test bad --config keys
>
>  Assorted config API updates.
>
>  Waiting for review.
>  source: <[email-masked]>

I see that ab/no-more-git-global-super-prefix has landed in "next", I
was planning to submit the built-in submodule topic after it, i.e. the
change to get rid of git-submodule.sh.

But the post-cleanup in that topic of moving the relevant code from
builtin/submodule--helper.c to builtin/submodule.c would conflict with
ab/config-multi-and-nonbool, as some of it uses the *_multi() API.

Now, it would be relatively easy to solve those conflicts, but I'd also
like to make it easier for you, Junio.

So more reviews on that topic would be most welcome. It fixes quite a
few segfaults we currently have in-tree, so I'm a bit surprised at the
relative lack of interest.